<?
	/**	
	 *	Mambo Site Server Open Source Edition Version 3.0.5
	 *	Dynamic portal server and Content managment engine
	 *	04-05-2001
 	 *
	 *	Copyright (C) 2000 - 2001 Miro Contruct Pty Ltd
	 *	Distributed under the terms of the GNU General Public License
	 *	This software may be used without warrany provided these statements are left 
	 *	intact and a "Powered By Mambo" appears at the bottom of each HTML page.
	 *	This code is Available at http://sourceforge.net/projects/mambo
	 *
	 *	Site Name: Mambo Site Server Open Source Edition Version 3.0.5
	 *	File Name: registration.php
	 *	Developers: Danny Younes - danny@miro.com.au
	 *				Nicole Anderson - nicole@miro.com.au
	 *	Date: 17/07/2001
	 * 	Version #: 3.0.5
	 *	Comments: Functions to retrieve lost passwords, register new users.
	**/
	
	require ("classes/html/registration.php");
	$registration = new registration();
	
	include ("configuration.php");
	
	switch($task) {
	    case "lostPassword":
			lostPassForm($registration, $option);
			break;
		case "sendNewPass":
			sendNewPass($checkusername, $confirmEmail, $option, $database, $live_site);
			break;
		case "register":
			registerForm($registration, $option);
			break;
		case "saveRegistration":
			saveRegistration($yourname, $username1, $email, $pass, $verifyPass, $option, $database, $live_site);
			break;
		}
	
	function lostPassForm($registration, $option){
		$registration->lostPassForm($option);
	}
	
	function sendNewPass($checkusername, $confirmEmail, $option, $database, $live_site){
		$query="select email from users where username='$checkusername' and email='$confirmEmail' and usertype='user'";
		$result=$database->openConnectionWithReturn($query);
		if (mysql_num_rows($result)==0){
				print "<SCRIPT> alert('Sorry, no corresponding user was found'); window.history.go(-1); </SCRIPT>\n";
		}else{
			$newpass= makepass();
			$message = "The user account '$checkusername' has this email associated with it.  A web user from $live_site has just requested that a new password be sent.\n\n Your New Password is: $newpass\n\nIf you didn't ask for this, don't worry. You are seeing this message, not them. If this was an error just login with your new password and then change your password to what you would like it to be.";
			$subject="User Password for $checkusername";
			mail($confirmEmail, $subject, $message, "From: Administration");
			$newpass=md5($newpass);
			$query="update users set password='$newpass' where username='$checkusername' and usertype='user'";
			$database->openConnectionNoReturn($query);
			echo "&nbsp;&nbsp;<BR><BR><B>New User Password Created And Sent!</B>";
			
		}
	}
	
	function makePass() {
		$makepass="";
		$syllables="er,in,tia,wol,fe,pre,vet,jo,nes,al,len,son,cha,ir,ler,bo,ok,tio,nar,sim,ple,bla,ten,toe,cho,co,lat,spe,ak,er,po,co,lor,pen,cil,li,ght,wh,at,the,he,ck,is,mam,bo,no,fi,ve,any,way,pol,iti,cs,ra,dio,sou,rce,sea,rch,pa,per,com,bo,sp,eak,st,fi,rst,gr,oup,boy,ea,gle,tr,ail,bi,ble,brb,pri,dee,kay,en,be,se";
		$syllable_array=explode(",", $syllables);
		mt_srand((double)microtime()*1000000);
		//srand((double)microtime()*1000000);
		for ($count=1;$count<=4;$count++) {
			if (mt_rand()%10 == 1) {
				$makepass .= sprintf("%0.0f",(mt_rand()%50)+1);
			} else {
				$makepass .= sprintf("%s",$syllable_array[mt_rand()%62]);
			}
		}
		return($makepass);
	}
	
	function registerForm($registration, $option){
		$registration->registerForm($option);
	}
	
	function saveRegistration($yourname, $username1, $email, $pass, $verifyPass, $option, $database, $live_site){
		if (trim($yourname)==""){
			print "<SCRIPT> alert('Please enter your name.'); window.history.go(-1); </SCRIPT>\n";
		}else if (trim($username1)==""){
			print "<SCRIPT> alert('Please enter a user name.'); window.history.go(-1); </SCRIPT>\n";
		}else if (trim($email)==""){
			print "<SCRIPT> alert('Please enter your email address.'); window.history.go(-1); </SCRIPT>\n";
		}else if (trim($pass)==""){
			print "<SCRIPT> alert('Please enter a password.'); window.history.go(-1); </SCRIPT>\n";
		}else if (trim($verifyPass)==""){
			print "<SCRIPT> alert('Please verify the password.'); window.history.go(-1); </SCRIPT>\n";
		}else if ($pass!=$verifyPass){
			print "<SCRIPT> alert('Password and verification do not match, please try again.'); window.history.go(-1); </SCRIPT>\n";
		}else{
			$query="select id from users where username='$username' and usertype='user'";
			$result=$database->openConnectionWithReturn($query);
			if (mysql_num_rows($result)!=0){
				print "<SCRIPT> alert('This username/password already in use. Please try another.'); window.history.go(-1); </SCRIPT>\n";
			}else{
				$cryptpass=md5($pass);
				$query="insert into users (name, username, email, password, usertype) values ('$yourname', '$username1', '$email', '$cryptpass', 'user')";
				$database->openConnectionNoReturn($query);
				
				$recipient = "$yourname <$email>";
				$subject = "New User Details";
				$message .= "Hello $yourname,\n\n";
				$message .= "You have been added as a user to '$live_site'.\n";
				$message .= "This email contains your username and password to log into the '$live_site' site:\n\n"; 
				$message .= "Username - $username1\n";
				$message .= "Password - $pass\n\n\n";
				$message .= "Please do not respond to this message as it is automatically generated and is for information purposes only\n";
						
				$headers .= "From: Administrator <$live_site>\n";
				$headers .= "X-Sender:<$live_site> \n"; 
				$headers .= "X-Mailer: PHP\n"; // mailer
				$headers .= "Return-Path: <$email>\n";  // Return path for errors
				mail($recipient, $subject, $message, $headers);
				
				$query2="select name, email from users where usertype='superadministrator' and sendEmail=1";
				$result2=$database->openConnectionWithReturn($query2);
				if (mysql_num_rows($result2)!=0){
					list($adminName, $adminEmail)=mysql_fetch_array($result2);
					$recipient2 = "$adminName <$adminEmail>";
					$subject2 = "New User Details";
					$message2 .= "Hello $adminName,\n\n";
					$message2 .= "A new user has registered at '$live_site'.\n";
					$message2 .= "This email contains their details:\n\n"; 
					$message2 .= "Name - $yourname\n";
					$message2 .= "Email - $email\n";
					$message2 .= "Username - $username1\n";
					$message2 .= "Please do not respond to this message as it is automatically generated and is for information purposes only\n";
						
					$headers2 .= "From: Administrator <$live_site>\n";
					$headers2 .= "X-Sender:<$live_site> \n"; 
					$headers2 .= "X-Mailer: PHP\n"; // mailer
					$headers2 .= "Return-Path: <$adminEmail>\n";  // Return path for errors
					mail($recipient2, $subject2, $message2, $headers2);
				} 
				echo "<BR><BR>&nbsp;&nbsp;<B>Registration Complete!</B><BR>&nbsp;&nbsp;Registration is complete, you may now log in with your username and password.";
			}
		}
	}
?>